StaticPopupDialogs["GOLDCAP_LIMIT"]={
	text="You have defined a gold character for this realm, however you have not yet set a limit for how much gold this character can hold.\nPlease enter this amount now:",
	button1=SAVE,
	button2=CANCEL,
	hasEditBox=true,
	EditBoxOnEnterPressed=function(self) self:GetParent().button1:Click() end,
	OnShow=function(self)
		self.button1:Disable()
		self.editBox:SetNumeric(true)
	end,
	EditBoxOnTextChanged=function(self)
		if strlen(self:GetText()) >0 then self:GetParent().button1:Enable() else self:GetParent().button1:Disable() end
	end,
	OnAccept=function(self)
		local v = self.editBox:GetNumber()
		GoldCap.opt.limits[(UnitName("player"))] = v*10000
		print("Gold limit for current character successfully set.")
		print("In the future, you can use |cff00ff00/goldcap amount|r to change this amount.")
	end,
	timeout=0,
	whileDead=true,
	hideOnEscape=true,
}
StaticPopupDialogs["GOLDCAP_SET"]={
	text="Welcome to GoldCap!\nUse |cffffd100/goldcap set|r to set a character as a realm's gold toon.\nLog onto your other characters to set their gold limits afterwards.",
	button1=OKAY,
	OnAccept=function()
		GoldCap_DB.noticeShown = true
	end,
	timeout=0,
	whileDead=true,
}
local addon = CreateFrame("Frame", "GoldCap")
addon:SetScript("OnEvent", function(self, event, ...)
	local args = {...}
	if event == "ADDON_LOADED" and args[1] == "GoldCap" then
		GoldCap_DB = GoldCap_DB or {}
		GoldCap_DB[GetRealmName().."-"..UnitFactionGroup("player")] = GoldCap_DB[GetRealmName().."-"..UnitFactionGroup("player")] or {limits={}}
		if not GoldCap_DB.noticeShown then
			StaticPopup_Show("GOLDCAP_SET")
		end
		addon.opt = GoldCap_DB[GetRealmName().."-"..UnitFactionGroup("player")]
		local pn = UnitName("player")
		if addon.opt.goldToon and not (addon.opt.goldToon == pn) and (not addon.opt.limits[pn]) then
			StaticPopup_Show("GOLDCAP_LIMIT")
		end
	end
	if event == "PLAYER_MONEY" or event == "MAIL_SHOW" then addon.button:Update() end
end)
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("PLAYER_MONEY")
addon:RegisterEvent("MAIL_SHOW")
function addon:SendMoney()
	ClearSendMail()
	local send = GetMoney()-addon.opt.limits[(UnitName("player"))]-30
	SetSendMailMoney(send)
	local gold = floor(abs(send / 10000))
	local silver = floor(abs(mod(send / 100, 100)))
	local copper = floor(abs(mod(send, 100)))
	local sendstring = ""
	if gold and (gold>0) then
		sendstring=sendstring..gold.."g"
	end
	if silver and (silver>0) then
		sendstring=sendstring..(strlen(sendstring)>0 and " " or "")..silver.."s"
	end
	if copper and (copper>0) then
		sendstring=sendstring..(strlen(sendstring)>0 and " " or "")..copper.."s"
	end
	SendMail(addon.opt.goldToon, "GoldCap: "..sendstring,"")
	print(("|c33cc33[GoldCap]|r Successfully sent %s to %s."):format(sendstring,addon.opt.goldToon))
end
SLASH_GOLDCAP1 = "/goldcap"
SlashCmdList["GOLDCAP"]=function(input)
	if input:lower():find("^set") then
		addon.opt.goldToon = (UnitName("player"))
		addon.opt.limits[(UnitName("player"))] = nil
		print("Your gold character for "..GetRealmName().." is now: |cffffd100"..(UnitName("player")).."|r!")
	elseif input:lower():find("^amount") then
		StaticPopup_Show("GOLDCAP_LIMIT")
	end
end
addon.button = CreateFrame("Button", "GoldCap_Button", MailFrame, "UIPanelButtonTemplate")
addon.button:SetPoint("BOTTOMLEFT", MailFrame, "TOPLEFT")
addon.button:SetPoint("BOTTOMRIGHT", MailFrame, "TOPRIGHT")
addon.button:SetHeight(50)
function addon.button:Update()
	local money = GetMoney()-30
	local limit = addon.opt.limits[(UnitName("player"))]
	if (not limit) or (money < limit) or (addon.opt.goldToon == UnitName("player")) then
		self:Hide()
	else
		self:Show()
		local send = money-limit
		local gold = floor(abs(send / 10000))
		local silver = floor(abs(mod(send / 100, 100)))
		local copper = floor(abs(mod(send, 100)))
		local sendstring = ""
		if gold and (gold>0) then
			sendstring=sendstring..gold.."g"
		end
		if silver and (silver>0) then
			sendstring=sendstring..(strlen(sendstring)>0 and " " or "")..silver.."s"
		end
		if copper and (copper>0) then
			sendstring=sendstring..(strlen(sendstring)>0 and " " or "")..copper.."s"
		end
		self:SetText("Click to send the following amount to "..addon.opt.goldToon..":\n"..sendstring)
	end
end
addon.button:SetScript("OnClick", function()
	addon:SendMoney()
end)